/*
 * plugin_gnc_filtersay.sma v 1.0b 03:42 26/05/2002
 * 
 *                       by 
 *       SR71Goku http://sr71goku.tripod.com/
 *                       and
 *      Caveman http://gosh.ex.ac.uk/~py99jan/
 *
 *            Please read the readme.txt
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define MAX_WORDS 70
#define MAX_PHRASE_LENGTH 40
#define MAX_LOOPS 10

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.26.";

/********************************************************/

new BadWord[MAX_WORDS+1][MAX_PHRASE_LENGTH];
new GoodWord[MAX_WORDS+1][MAX_PHRASE_LENGTH];

public plugin_init() {
	snprintf(STRING_VERSION,MAX_DATA_LENGTH,"%s%d",STRING_VERSION,MAX_WORDS);
	plugin_registerinfo("Profanity Filter","Goku and Cavey Present - The full profanity filter.",STRING_VERSION);
	
	plugin_registercmd("say","handlesay",ACCESS_ALL);
	plugin_registercmd("say_team","handlesay",ACCESS_ALL);
	
	readcfg("filter.txt");
	
	return PLUGIN_CONTINUE;
}

public handlesay(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Speech[MAX_TEXT_LENGTH];
	new Data1[MAX_DATA_LENGTH];
	new Data2[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new edited = 0;
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Speech,MAX_TEXT_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	/*Loops until it runs out of words*/
	for (new i=0;(i<MAX_WORDS && strlen(BadWord[i]) != 0);i++){
		new j=0;
		while(strcasestr(Speech,BadWord[i])!=-1 && j<MAX_LOOPS){
			split(Speech, BadWord[i], Data1, MAX_DATA_LENGTH, Data2, MAX_DATA_LENGTH);
			snprintf(Speech,MAX_TEXT_LENGTH,"%s%s%s",Data1,GoodWord[i],Data2);
			edited = 1;
			j++;
		}
	}
	
	if (edited != 0	){
		snprintf(Speech,MAX_TEXT_LENGTH,"%s %s",Command,Speech);
		execclient(User,Speech);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

readcfg(filename[]){
	new sData[MAX_DATA_LENGTH];
	
	/*Loops until it runs out of memory or runs out of file*/
	if (fileexists(filename)){
		for (new i=0;(i<MAX_WORDS && readfile(filename,sData,(i+1),MAX_DATA_LENGTH));i++){
			strgsplit(sData, " ", "^"", BadWord[i], MAX_PHRASE_LENGTH, GoodWord[i], MAX_PHRASE_LENGTH);

		}
	} else {
		say("File not found");
	}
}

/*Cavey's split function 1.0.  Please leave this tag here*/
split(sSource[], sToken[], sData1[], iLen1, sData2[], iLen2){
	new start = strcasestr(sSource,sToken);
	strncpy(sData1,sSource,start,iLen1);
	new j=0;
	for (new i=(start+strlen(sToken));((i<=strlen(sSource)) && (j<iLen2));i++){
		sData2[j++]=sSource[i];
	}
	sData2[j+1] = 0;
}
